//----------------------------------------------------------------------------
// pacman-like game
// copyright 2010 christopher rasmussen
// university of delaware
// v. 1.0

//----------------------------------------------------------------------------

#include "RunnerAgent.hh"

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

// STUDENTS SET THIS

const int MAXIMUM_DEPTH_FOR_MINIMAX   = 1;

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

// HONORS STUDENTS WRITE THIS FOR LAB 7

void Dijkstra(Point_2D start, BlockMaze *M)
{

}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

// is this the end of the "game"?  if so, who won?

bool terminal_state(float & utility, const GameState & GS, BlockMaze *M)
{
  int which_ghost;

  if (GS.check_for_runner_caught(which_ghost) && GS.blue_ghost_wait_counter == 0) {
    utility = UTILITY_GHOST_WIN; 
    return true;
  }
  else if (GS.check_for_level_cleared()) {
    utility = UTILITY_RUNNER_WIN; 
    return true;
  }
  else
    return false;
}

//----------------------------------------------------------------------------

// should we stop searching and apply eval() to this GameState?

bool cutoff_test(int depth, const GameState & GS, BlockMaze *M)
{
  if (depth >= MAXIMUM_DEPTH_FOR_MINIMAX)
    return true;
  else
    return false;
}

//----------------------------------------------------------------------------

// STUDENTS WRITE THIS FOR PROJECT 3

// how good is this GameState for the runner and the ghosts?
// bigger is better for the runner (up to a max of UTILITY_RUNNER_WIN), 
// smaller is better for the ghosts (down to a min of UTIILTY_GHOST_WIN)

float eval(const GameState & GS, BlockMaze *M)
{
  // return ???
}

//----------------------------------------------------------------------------

// STUDENTS WRITE THIS FOR PROJECT 3

// runner_turn: is this level of game tree the runner making a move or the ghosts?
// depth: how far down the game tree are we (0 = root)
// GS, M: state of game to compute value for
// best_value: what is the computed value? (should be filled in by this function)
// best_move: where should the agent whose turn it is go? (should be filled in by this function)

// return value = true: best_move has been filled in (i.e., there is a move to make)
// return value = false: there is no best_move because GS is a leaf of game tree
 
bool minimax_value(bool runner_turn, int depth, const GameState & GS, BlockMaze *M, float & best_value, Point_2D & best_move)
{
  // is the game over?

  if (terminal_state(best_value, GS, M))   // if true, true utility is filled in at best_value
    return false;

  // are we at the depth limit of our search?  if so, call eval() to estimate utility

  else if (cutoff_test(depth, GS, M)) {
    best_value = eval(GS, M);
    return false;
  }

  // runner's turn: which successor of GS has MAX minimax_value()?

  else if (runner_turn) {

    // ???

    return true;

  }

  // ghosts' turn: which successor of GS has MIN minimax_value()?

  else {

    // ???

    return true;

  }
}

//----------------------------------------------------------------------------

// ALL STUDENTS WRITE THIS FOR PROJECT 3

// ad-hoc ok for "Ghosts" scenario, but must use minimax for "Power Pills Work!" and "The Arena"

void RunnerAgent::update(const GameState & GS, BlockMaze *M)
{
  // uncomment for total manual control

  return;

  // uncomment to use minimax method

//   if (minimax_value(true, 0, GS, M, best_minimax_value, best_minimax_move))
//     attempt_move(best_minimax_move.row, best_minimax_move.col, M);

  // fill in here to use ad-hoc, no-minimax approach (in which case the two lines about minimax 
  // above should be commented out)

  // ???

}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

